#ifndef _matsum_n_
#define _matsum_n_

#include "./utils/vector.h"
#include "./utils/matrix.h"
#include "./core/omp_config.h"

namespace numerics{
	
	template <typename T>
	utils::Vector<T> matsum(const utils::Matrix<T>& A, std::string method) {

		utils::Vector<T> b;

		if (method == "row"){
			b.resize(A.cols(), T{0});
			for (uint64_t i = 0; i < A.cols(); ++i){
				for (uint64_t j = 0; j < A.rows(); ++j){
					b[i] += A(j, i); 
				}
			}
		}else if (method == "col"){
			b.resize(A.rows(), T{0});

			for (uint64_t i = 0; i < A.cols(); ++i){
				for (uint64_t j = 0; j < A.rows(); ++j){
					b[j] += A(j, i); 
				}
			}
		}else{
			throw std::runtime_error("matsum: choose sum by: 'row' or 'col'");
		}
		return b;
	}


} // namespace numerics

#endif // _matadd_n_